<?php

/************************************************************************************************
  *  Cette classe sert a crer un qcm en pdf dynamique (contenant du javascript)
  *  classe crite par Constant Chartier dans le cadre du projet QCMC2i,  l'IUT de Vannes
  *  constant2003@wanadoo.fr
  *  classe modifie par Michel Dubois
  *  duboismf@yahoo.fr
  ***********************************************************************************************/

include_once('fpdf_protection.php');
//Permet d'utiliser des CheckBox (entre autres)
include_once('js_form.php');
//pour faire du...pdf
include_once('fpdf/fpdf.php');
//error_reporting(0);
class QCM{

//variables globales
var $index=0;
var $liste=array();
var $bonne=array();
var $pdf;

/* Cette fonction cr un pdf Dynamique (contenant du javascript)
 * Les questions et les rponses sont rcupres dans une base de donnes mySql
 *
 * $needMdp : O-> pas de mdp ; 1-> mot de passe (pour la correction)
 * $mdp : mot de passe pour acceder a la correction
 * $bddUser : Nom d'utilisateur pour la base de donnes
 * $bddPass : Mot de passe de la base de donnes
 * $bddName : Nom de la base de donnes
 * $bddPlace : Location de la base de donnes
 * $download : 0-> le fichier s'ouvre dans le navigateur ; 1-> Tlchargement du fichier
 * $showTime : 0-> pas de temps ; 1-> Affichage du temps
 * $minutes : Temps max (en minutes) pour faire le qcm  0-> temps infini
 * $ref : Contient les rfrentiels dans lesquels on doit puiser les questions
 * $niveaumin : niveau minimal des questions  prendre
 * $niveaumax : niveau maximal des questions  prendre 
 * $coeff : Contient les coefficients des rfrentiels dans lesquels on doit puiser les questions
 * $nbQuestions : Contient le nombre de question a utiliser (par rfrentiel)
 * $pts : Contient dans l'ordre : les points pour une bonne rponse, une mauvaise rponse, une question non rpondue
 * $dynamique : 0-> pdf statique; 1-> pdf dynamique
 * $titre : Titre du QCM
 * $corrigeDisp : pour un pdf statique : 0-> pdf statique vierge; 1-> pdf statique corrige
 * $sql : requete sql qui permet de rcuprer les id des questions dans la premire colonnes. Ce qui permet la clause ORDER BY
 * $detail : affichage avant la question de certaines de ses caractristiques
 * $nomfichier : nom du fichier  produire
 * $protection : protection du pdf  produire : 0=non crypte, 1=crypte avec impression, 2=crypte sans impression
 * $countdown : 0=simple horloge 1=compte  rebours 
 * $mdpvisu : mot de passe pour la visualisation du pdf (protection standart)
 * $AbsoluteLink : 0=Pas de transformation 1=le paramtre $CFG->URLlinkbase est utilis pour transformer les liens relatifs en liens absolus 
*/
function createQcm($needMdp, $mdp, $bddUser, $bddPass, $bddName, $bddPlace, $download, $showTime, $minutes, $ref, $niveaumin, $niveaumax, $coeff, 
                   $nbQuestions, $pts, $dynamique, $titre,$corrigeDisp=false,$sql="",$detail=false,$nomfichier='qcm.pdf',$calcduree=false,$protection=0,$countdown=1,$mdpvisu="",$AbsoluteLink=0){

//echo $sql;
    require_once('config.php');
 	global $CFG;	

	if($dynamique==0) $showTime=0;
	if($showTime==0) $minutes=0;

    $this->pdf=new FPDF_Protection();
    if ($protection==1) {
      if($dynamique==1) $this->pdf->SetProtection(array('print','modify','annot-forms'),$mdpvisu,$CFG->pdfmpwd);
      if($dynamique==0) $this->pdf->SetProtection(array('print'),$mdpvisu,$CFG->pdfmpwd);
    }
    if ($protection==2) {
      if($dynamique==1) $this->pdf->SetProtection(array('modify','annot-forms'),$mdpvisu,$CFG->pdfmpwd);
      if($dynamique==0) $this->pdf->SetProtection(array(),$mdpvisu,$CFG->pdfmpwd);
    }

    //Choix de la police
	$this->pdf->SetFont('Arial','',11);
	
	  if ($protection==false) {
	    //chiffrement en md5
      $mdp = md5($mdp);
    }
    //On ouvre un nouveau document pdf
    $this->pdf->Open();
    //On ajoute une premiere page
    $this->pdf->AddPage();
    if($showTime==1){
        //On affiche une zone de texte (dans laquelle sera crit le temps)
        $this->pdf->SetX(185);
        if ($countdown==0)
          $this->pdf->TextField('horloge',13,5,array('BorderColor'=>'ltGray','TextColor'=>'red'));
        else
          $this->pdf->TextField('horloge',15,5,array('BorderColor'=>'ltGray','TextColor'=>'red'));

    }
    //On ajoute le logo
    //70:abscisse du coin suprieur gauche 20:ordonne du coin suprieur gauche 60:largeur souhaite
    
	$this->pdf->Image($CFG->dirroot."/textures/Logo_C2I.png",60,10,60);
    $this->pdf->Image($CFG->dirroot."/textures/Logo_UBS.png",120,8,30);
    $this->pdf->Ln(30);
    //le premier 1 sert a encadrer le texte, le second a passer une ligne apres
    //Le dernier sert a spcifier que le fond doit etre color
    //Le 'C' sert a centrer le texte dans le cadre
    //190 -> Espacement Horizontal
    //10 -> Espacement vertical
    $this->pdf->SetFont('Arial','',16);

    //histoire de colorer le fond du cadre (en bleu !)
    $this->pdf->SetFillColor(200,220,255);
    $this->pdf->Cell(190,10,$titre,1,1,'C',1);
    $this->pdf->Ln(15);

    //connexion a la base de donnes
    mysql_connect ("$bddPlace","$bddUser","$bddPass");
    mysql_select_db ("$bddName");

    //On change la taille de la police
    $this->pdf->SetFont('','',11);

    //Changement de couleur (bleu)
    $this->pdf->SetFillColor(200,220,255);
  
  // il faut choisir les questions de maniere aleatoire selon des criteres
    if ($sql=="") {
	     //Pour chaque rfrentiel on tire au sort un nb de question
	     //qu'on affiche ensuite
	     //le nombre de question de chaque rfrentiel est pass en paramtre
	     //$ref=array('B1', 'B2');        -> Contient le nom des rfrentiels
	     //$nbQuestions=array(6,15);      -> Contient le nombre de questions pour chaque rfrentiel
	
	     //On parcourt le tableau des rfrentiels et on cre des tableaux contenant les idQuestion
	     //On ne slectionne que les questions de niveau $diff
	     $tab=array();
	     for ($i=0; $i<=count($ref)-1; $i++){
		    $tab[$i]=$this->chargeIdQuestion($ref[$i],$niveaumin,$niveaumax);
	     }

	     //On vrifie que les trois tableaux font la mme taille
	     if (count($ref)!=count($nbQuestions)){
		    echo 'Erreur : les tableaux $nbQuestions et $ref doivent faire la mme taille';
		    //On arrete le traitement
		    exit();
	     }
	     //On vrifie qu'on ne nous demande pas plus de question qu'il n'y en a dans le rfrentiel
	     for ($i=0; $i<=count($ref)-1; $i++){
		    if ($nbQuestions[$i]>count($tab[$i])){
          echo "Attention ".$ref[$i]." : ".$nbQuestions[$i]." ".count($tab[$i]);

			    echo "Erreur : Il n'y a pas assez de questions dans le rfrentiel ".$ref[$i];
			    //On arrete le traitement
			    exit();
		    }
	    }
	
	    //On parcourt ensuite le tableau contenant le nombre de questions
	    //et on affiche $nbQuestions[n] questions tires au sort pour chaque rfrentiel
	    $x=0;
	    $afficheLien="";
	    $dejaTiree=array(); //ce tableau sert a viter les doublons
      $refQ=array();      
      $num=1;
	    //pour chaque rfrentiel
	    for ($i=0; $i<=count($nbQuestions)-1; $i++){
		    //on tire $nbQuestions[$i] questions
		    for ($j=0; $j<=$nbQuestions[$i]-1; $j++){
			   do {
				  //au hasard
				  $id = rand(0, count($tab[$i])-1);
				  //On associe au numro tir un id de question
				  $id = $tab[$i][$id];
			   }
			   //On recommence si le numro a dja t tir
			   while ($this->estDans($id,$dejaTiree));
			
			     //On l'enregistre dans la liste des questions tires
			     $dejaTiree[]=$id;			
			     //et on affiche la question
			     $this->pdf=$this->afficheQuestion($id, $dynamique,$num,$corrigeDisp);
           array_push( $refQ , $ref[$i] );
           $num=$num+1;
			     //pour afficher les liens dans les champs prvu, apres la correction
			     //requete pour obtenir le lien
			     $query = "select lien from question where idQuestion=$id;";
			     $question = mysql_query ($query);
			     $lien = mysql_fetch_array ($question);
			     $x++;
			     if ($lien[0]!='' && $corrigeDisp==true) {
				 if ((strcasecmp(substr($lien[0],0,7),"http://")!=0) && (strcasecmp(substr($lien[0],0,6),"ftp://")!=0) && (strcasecmp(substr($lien[0],0,7),"file://")!=0) && $AbsoluteLink==1)
						$lien[0]="$CFG->URLlinkbase/".$lien[0];
			      $afficheLien.="f=getField('lien$x');\n";
            $afficheLien.="    f.value ='$lien[0]';\n";
            $afficheLien.="    f.setAction('MouseUp','getURL(\"".$lien[0]."\")');\n";
            $afficheLien.="    f.setAction('Validate','event.value =\"$lien[0]\";');\n";
//            $afficheLien.="    f.setAction('OnFocus','event.value =\"$lien[0]\";');\n";
//            $afficheLien.="    f.setAction('OnBlur','event.value =\"$lien[0]\";');\n";
            $afficheLien.="    f.readonly = false;\n";
			$afficheLien.="    f.display = display.noPrint;\n";
            $afficheLien.="    f.userName = 'Aller  la ressource de la question n $num';\n";
           }
		    }
	
	    }
	  } else {
       // les question et leur ordre d'apparition est dfini dans la requete sql
	    $x=0;
	    $afficheLien="";
      $num=1;
	    $refQ=array();
	    $idQ=array();
	    $coeff=array();
	    $nbQuestions=array();
      $ref=array();
      $questionsql = mysql_query ($sql);
	  $nb = mysql_numrows($questionsql);
	  if ($nb==0) die("Il y a aucune question dans la slection !");  
      while ($qcmq = mysql_fetch_array ($questionsql)){
			     //pour afficher les liens dans les champs prvu, apres la correction
			     //requete pour obtenir le lien
			     $query1 = "select lien,idQuestion,question.idReferentiel,question.ordre,niveau,referentiel.intitule AS intref, alinea.intitule AS intal from question,alinea,referentiel where idQuestion=$qcmq[0] and question.idReferentiel=alinea.idReferentiel and alinea.ordre=question.ordre AND referentiel.idReferentiel = question.idReferentiel;";
	         //echo $query1."<br/>";
			     $question1 = mysql_query ($query1);
			     $lien = mysql_fetch_array ($question1);			      
			     array_push( $idQ , $qcmq[0]);
			     array_push( $refQ , $lien['idReferentiel']);
			     $x++;
			     if ($lien[0]!='' && $corrigeDisp==true) {
				 	if ((strcasecmp(substr($lien[0],0,7),"http://")!=0) && (strcasecmp(substr($lien[0],0,6),"ftp://")!=0) && (strcasecmp(substr($lien[0],0,7),"file://")!=0) && $AbsoluteLink==1)
						$lien[0]="$CFG->URLlinkbase/".$lien[0];
			      $afficheLien.="f=getField('lien$x');\n";
            $afficheLien.="    f.value ='$lien[0]';\n";
            $afficheLien.="    f.setAction('MouseUp','getURL(\"".$lien[0]."\")');\n";
            $afficheLien.="    f.setAction('Validate','event.value =\"$lien[0]\";');\n";
//            $afficheLien.="    f.setAction('OnFocus','event.value =\"$lien[0]\";');\n";
//            $afficheLien.="    f.setAction('OnBlur','event.value =\"$lien[0]\";');\n";
            $afficheLien.="    f.readonly = false;\n";
			$afficheLien.="    f.display = display.noPrint;\n";
            $afficheLien.="    f.userName = 'Aller  la ressource de la question n $num';\n";
           }
           if ($detail==true) {
			       $this->pdf->Cell(40,4,stripCSlashes("{ ID=".$lien['idQuestion']." Ref=".$lien['idReferentiel']." Alinea=".$lien['ordre']." niveau=".$lien['niveau']."}"),0,1);
			       $this->pdf->Cell(40,4,stripCSlashes("{".substr($lien['intref'],0,107)."}"),0,1);	
             $this->pdf->Cell(40,4,stripCSlashes("{".substr($lien['intal'],0,107)."}"),0,1);			     
           }
           $this->pdf=$this->afficheQuestion($qcmq[0], $dynamique,$num,$corrigeDisp);			     
           $num=$num+1;	
	    }
	    if ($calcduree==true) $minutes=floor($num*1.5);
	    $where="IN(";
	    for ($i=0; $i<=count($idQ)-1; $i++) {
	     if ($i!=0)  $where.=',';
	     $where.=$idQ[$i];
	    }
	    $where.=')';
	    $sql1="SELECT DISTINCT question.idReferentiel,ponderation,COUNT(idQuestion) AS nb FROM referentiel,question WHERE question.idReferentiel=referentiel.idReferentiel AND idQuestion $where GROUP BY question.idReferentiel,ponderation ";
      $sql1.="UNION SELECT referentiel.idReferentiel, ponderation, 0 AS nb FROM referentiel WHERE idReferentiel NOT IN (SELECT referentiel.idReferentiel FROM referentiel JOIN question ON question.idReferentiel = referentiel.idReferentiel WHERE idQuestion $where) ORDER BY idReferentiel;";
     
      $question1 = mysql_query ($sql1);
			while ($rep1 = mysql_fetch_array ($question1)){
			  array_push( $ref , $rep1['idReferentiel'] );
        array_push( $coeff , $rep1['ponderation'] );
			  array_push( $nbQuestions , $rep1['nb'] );			  
      }
    }
  $quiztimervalue=$minutes*60;  	
	if($dynamique==0){
	//Propose l'affichage ou le tlchargement
	  if ($download==0){
        //affichage du pdf
        $this->pdf->Output();
    }
    else{
        //proposer en tlchargement au lieu d'afficher
        $this->pdf->Output($nomfichier,'D');   //D pour Download
    }
		exit();
	}
	
		//On ajoute le bouton pour valider
		//On saute une ligne
		$this->pdf->Ln(10);
	
		if ($needMdp==1){//Si besoin d'un mdp,
			//Insertion d'un champ avec mot de passe
			$this->pdf->Cell(35,5,'Mot de passe :');
			$this->pdf->TextField('mdp',30,5,array('BorderColor'=>'black'));
			$this->pdf->Ln(6);
		}
	
		//On se positionne vers le milieu de la page
		$this->pdf->SetX(90);
		//Et on insere le bouton
		//25:Largeur
		//8:Hauteur
		$this->pdf->Button('Valider',25,8,'Valider','verifMdp()',array('TextColor'=>'yellow','FillColor'=>'blue'));
	
	
		//On cre une nouvelle page qui sera complte apres la correction
		//Cette page contient :
		//					- nombre de bonnes rponses
		//					- nombre de mauvaises rponses
		//					- nombre de rponses non rpondues
		//					- points par bonne rponse
		//					- points par mauvaise rponse
		//					- points par rponse non rpondue
		//					- note
	
		$this->pdf->AddPage();
    //On ajoute le logo
    //70:abscisse du coin suprieur gauche 20:ordonne du coin suprieur gauche 60:largeur souhaite
    $this->pdf->Image($CFG->dirroot."/textures/Logo_C2I.png",60,10,60);
    $this->pdf->Image($CFG->dirroot."/textures/Logo_UBS.png",120,8,30);
    $this->pdf->Ln(30);

		$this->pdf->Cell(190,10,'VOS RESULTATS',1,1,'C',1);
		$this->pdf->Ln(15);
		$this->pdf->Cell(75,5,'Bonnes rponses :');
		$this->pdf->TextField('nbBR',30,5,array('BorderColor'=>'black'));
		$this->pdf->Ln(6);
		$this->pdf->Cell(75,5,'Mauvaises rponses :');
		$this->pdf->TextField('nbMR',30,5,array('BorderColor'=>'black'));
		$this->pdf->Ln(6);
		$this->pdf->Cell(75,5,'Question non rpondues:');
		$this->pdf->TextField('nbNR',30,5,array('BorderColor'=>'black'));
		$this->pdf->Ln(6);
		$this->pdf->Cell(75,5,'Points pour une bonne rponse :');
		$this->pdf->TextField('ptsBR',30,5,array('BorderColor'=>'black'));
		$this->pdf->Ln(6);
		$this->pdf->Cell(75,5,'Points pour une mauvaise rponse :');
		$this->pdf->TextField('ptsMR',30,5,array('BorderColor'=>'black'));
		$this->pdf->Ln(6);
		$this->pdf->Cell(75,5,'Points pour une question non rpondue :');
		$this->pdf->TextField('ptsNR',30,5,array('BorderColor'=>'black'));
		$this->pdf->Ln(6);
		$this->pdf->Cell(75,5,'Note :');
		$this->pdf->TextField('note',30,5,array('BorderColor'=>'black','TextColor'=>'red'));
		$this->pdf->Ln(15);
		$this->pdf->Cell(190,10,'VOTRE POSITIONNEMENT PAR REFERENTIEL EN %',1,1,'C',1);
		$this->pdf->Ln(15);
	$this->pdf->script.="
for (var p = 0; p < this.numPages; p++) {
  //on cre un champ de formulaire de type texte en bas  droite de la page
  var f=getField('numpage'+p);
  if (f==null) f = addField('numpage'+p, 'text', p, [448,54,571,17] );
  //on dfinit les proprits du champ quon vient de crer
    //f.delay = true;
    f.textSize = 10; //taille du texte
    f.textColor = color.black; //couleur du texte
    f.textFont = font.Times; //police de caractre
    f.value = 'page '+ (p+1) +' sur '+ this.numPages; //valeur du champ
    f.readonly = true; //on rend le champ non modifiable
    f.display = display.visible;
    //f.delay = false;
}
";
  for ($i=0; $i<=count($nbQuestions)-1; $i++){
	  if ($nbQuestions[$i]>=2)
	     $qst='questions';
    else
       $qst='question';
          
    $this->pdf->Cell(75,5,$ref[$i].' (coefficient='.$coeff[$i].'), '.$nbQuestions[$i].' '.$qst.' :');
		$this->pdf->TextField("p".($i+1),30,5,array('BorderColor'=>'black'));
		$this->pdf->Ln(6);
  }
  /*
		$this->pdf->Cell(75,5,'A1 (coefficient=1) :');
		$this->pdf->TextField('pA1',30,5,array('BorderColor'=>'black'));
		$this->pdf->Ln(6);
		$this->pdf->Cell(75,5,'A2 (coefficient=3) :');
		$this->pdf->TextField('pA2',30,5,array('BorderColor'=>'black'));
		$this->pdf->Ln(6);
		$this->pdf->Cell(75,5,'B1 (coefficient=2) :');
		$this->pdf->TextField('pB1',30,5, array('BorderColor'=>'black'));
		$this->pdf->Ln(6);
		$this->pdf->Cell(75,5,'B2 (coefficient=2) :');
		$this->pdf->TextField('pB2',30,5,array('BorderColor'=>'black'));
		$this->pdf->Ln(6);
		$this->pdf->Cell(75,5,'B3 (coefficient=2) :');
		$this->pdf->TextField('pB3',30,5,array('BorderColor'=>'black'));
		$this->pdf->Ln(6);
		$this->pdf->Cell(75,5,'B4 (coefficient=2) :');
		$this->pdf->TextField('pB4',30,5,array('BorderColor'=>'black'));
		$this->pdf->Ln(6);
		$this->pdf->Cell(75,5,'B5 (coefficient=2) :');
		$this->pdf->TextField('pB5',30,5,array('BorderColor'=>'black'));
		$this->pdf->Ln(6);
		$this->pdf->Cell(75,5,'B6 (coefficient=3) :');
		$this->pdf->TextField('pB6',30,5,array('BorderColor'=>'black'));
		$this->pdf->Ln(6);
		$this->pdf->Cell(75,5,'B7 (coefficient=3) :');
		$this->pdf->TextField('pB7',30,5,array('BorderColor'=>'black'));
    $this->pdf->Ln(15);
    */
    $this->pdf->Ln(9);
		$this->pdf->Cell(190,10,'VOTRE POSITIONNEMENT C2i EN %',1,1,'C',1);
		$this->pdf->Ln(15);
		$this->pdf->Cell(75,5,'Positionnement C2i :');
		$this->pdf->TextField('pC2I',30,5,array('BorderColor'=>'black'));
	
	//Ce bout de code a pour but de rendre invisibles / visibles tous les checkbox de correction
	//Pour cela on dispose d'un tableau ($this->liste) en php
	//et bah c'est pas facile !!!
	//Le \n sert a faire un retour a la ligne dans le fichier
	$invisible="";
	$visible="";
	$readOnly="";
	$lockLien="";
	$noprint="";
  $creac="";
  $crear="";
  
	//sert a compter les points du candidat (sera utilis dans la partie JavaScript)
	$corriger="
	  nbQ=new Array();
	  nbQBR=new Array();
	  nbQMR=new Array();
	  nbQNR=new Array();
	  coeff=new Array();
	  Q=new Array();
	  nbQ[0]=$this->index;
	  nbQBR[0]=0;
	  nbQMR[0]=0;
	  nbQNR[0]=0;
		var ptsBR=$pts[0];
		var ptsMR=$pts[1];
		var ptsNR=$pts[2];
		var nbBR=0;
		var nbMR=0;
		var nbNR=0;
		var bon;
		var qnr;
	";
	for ($i=0; $i<=count($nbQuestions)-1; $i++){
	$corriger.="
	  nbQ[".($i+1)."]=$nbQuestions[$i];
	  nbQBR[".($i+1)."]=0;
	  nbQMR[".($i+1)."]=0;
	  nbQNR[".($i+1)."]=0;
	  coeff[".($i+1)."]=$coeff[$i];
	";}
	
	for($j=1;$j<=$this->index;$j++){
	  for ($i=0; $i<=count($nbQuestions)-1; $i++){
      if ($refQ[$j-1]==$ref[$i])
	      $corriger.="Q[".($j-1)."]=".($i+1).";
	       ";
    }
  }
	$corriger.="
	for (i=1;i<=Q.length;i++) {
    bon=1;
	  qnr=1;
	  f=getField('r'+i);
	  if (f==null) {
	    j=1;	   
	    while (getField('r'+i+'-'+j)!=null) {
	      if(getField('r'+i+'-'+j).value != getField('c'+i+'-'+j).value){
				  bon=0;
			  }
			  if(getField('r'+i+'-'+j).value == 'Oui'){
				  qnr=0;
			  }
        j++;
      } 
    } else {
			if(getField('r'+i).value == 'Oui'){
				qnr=0;
				bon=1;
			} else if(getField('r'+i).value == 'Non'){
				qnr=0;
				bon=0;
			}	else {
				bon=0;
				qnr=1;
			}    
    }
    if (qnr==1 && bon==0){
  		nbQNR[0]++;
			nbQNR[Q[i]]++;
		}
		else if(bon==1){
				nbQBR[0]++;
				nbQBR[Q[i]]++;
		} else{
				nbQMR[0]++;
				nbQMR[Q[i]]++;
		}
  }
  console.println(util.printf('Non repondues:%d',nbQNR[0]))
  console.println(util.printf('Bien repondues:%d',nbQBR[0]))
  console.println(util.printf('Mal repondues:%d',nbQMR[0]))				

	";
 	$invisible.="
  for (i=1;i<=$this->index;i++) {
	  j=1;	   
	  while (getField('c'+i+'-'+j)!=null) {
      getField('c'+i+'-'+j).display = display.hidden;
      j++;
    } 
  } 
  ";
/*
 	$noprint.="
  for (i=1;i<=$this->index;i++) {
	  j=1;	   
	  while (getField('c'+i+'-'+j)!=null) {
      getField('c'+i+'-'+j).print=false;
      j++;
    } 
  }   
  ";
*/
if ($corrigeDisp==true) 
  $visible.="
  for (i=1;i<=$this->index;i++) {
	  j=1;	   
	  while (getField('c'+i+'-'+j)!=null) {
      getField('c'+i+'-'+j).display = display.noPrint;
      j++;
    } 
  } 
  ";
else
  $visible.="
  for (i=1;i<=$this->index;i++) {
	  j=1;	   
	  while (getField('c'+i+'-'+j)!=null) {
      getField('c'+i+'-'+j).display = display.hidden;
      j++;
    } 
  } 
  ";
  
  $invisible.="
  for (i=1;i<=$this->index;i++) {
	  j=1;	   
	  while (getField('c'+i+'-'+j)!=null) {
      getField('c'+i+'-'+j).readonly = true;
      j++;
    } 
  } 
  ";
  $lockLien.="
  for (i=1;i<=$this->index;i++) {	
    getField('lien'+i).readonly = true;
  }
  ";
  $readOnly="
  for (i=1;i<=$this->index;i++) {	
    f=getField('r'+i);
	  if (f==null) {
	    j=1;	   
	    while (getField('r'+i+'-'+j)!=null) {
	      getField('r'+i+'-'+j).readonly = true;
			  j++;
      } 
    } else {
			getField('r'+i).readonly = true;
	  }	
  }
  ";
  
  $creac.="
  for (i=1;i<=$this->index;i++) {
	  j=1;
    f=getField('c'+i+'-'+j);	   
	  while (f!=null) {
      f.textSize=11;
      f.textColor=color.red;
      f.fillColor=color.blue;
      f.strokeColor=color.black;
      j++;
      f=getField('c'+i+'-'+j);
    } 
  } 
  ";
 $crear.="
  for (i=1;i<=$this->index;i++) {	
    f=getField('r'+i);
	  if (f==null) {
	    j=1;
      f=getField('r'+i+'-'+j);	   
	    while (f!=null) {
        f.textSize=11;
        f.value='Off';
        f.strokeColor=color.black;
			  j++;
			  f=getField('r'+i+'-'+j);
      } 
    } else {
      f.textSize=11;
      f.strokeColor=color.black;
	  }	
  }
  ";
	//fermeture de la base de donnes
    mysql_close();

    if ($needMdp==1){//Si besoin d'un mdp
	$this->pdf->script.="
	//On transforme le champs mot de passe
	getField('mdp').password=true;
	getField('mdp').display = display.noPrint;
	";
      //------------------------------------------------------------------------------------------------------------------

    }
	//Insertion du script qui sera dans le document pdf
	$this->pdf->script.="

    //se dclenche  l'ouverture du document

    //On verifie la version d'Acrobat (il faut au moins la version 4)
    if(app.viewerVersion < 5){
           //La version est trop vieille, on previent l'utilisateur
           app.alert('La version 5 ou superieur est conseille, certaines fonctionnalits peuvent ne pas marcher');
    }
	
	// on affiche le bareme tout de suite
    var esp='  ';
	var ptsBR=$pts[0];
	var ptsMR=$pts[1];
	var ptsNR=$pts[2];
	getField('ptsBR').value = esp + ptsBR;
	getField('ptsMR').value = esp + ptsMR;
	getField('ptsNR').value = esp + ptsNR;
		
    //On rend les champs de correction invisibles
    //et en lecture seule
	getField('nbBR').readonly = true;
	getField('nbMR').readonly = true;
	getField('nbNR').readonly = true;
	getField('ptsBR').readonly = true;
	getField('ptsMR').readonly = true;
	getField('ptsNR').readonly = true;
	getField('note').readonly = true;
  getField('pC2I').readonly = true;
";
	for ($i=0; $i<=count($nbQuestions)-1; $i++){
		$this->pdf->script.="
  getField('p".($i+1)."').readonly = true;";
  }
$this->pdf->script.="
  $crear
  $creac
  $noprint
	$invisible
	//Les champs de texte pour l'affichage des liens sont en lecture seule
	$lockLien

    //On verifie le type d'Acrobat (Reader ou Pro)
    if(app.viewerType == 'Reader'){

      //On appelle la fonction horloge toutes les secondes

      if($showTime==1 && $countdown==0){
        h1=1;
        h2=0;
            s=app.setInterval ('horloge()',1000);
      }
      if($showTime==1 && $countdown==1){
        quizTimerValue=$quiztimervalue;
            s=app.setInterval ('countdown_clock()',1000);
      }
    } else {
       var nButton = app.alert({ cMsg: \"Acrobat Reader n'tant pas dtect, Voulez vous cependant remplir le QCM ?\", nIcon: 2, nType: 2 });
       if ( nButton == 4 ) {
        //On appelle la fonction horloge toutes les secondes
       if($showTime==1 && $countdown==0){
          h1=1;
          h2=0;
          s=app.setInterval ('horloge()',1000);
        }
        if($showTime==1 && $countdown==1){
          quizTimerValue=$quiztimervalue;
          s=app.setInterval ('countdown_clock()',1000);
        }
       } else {
          s=app.setInterval ('acropro()',1000);
       }
    }

   //------------------------------------------------------------------------------------------------------------
//                            FONCTIONS JAVASCRIPT //------------------------------------------------------------------------------------------------------------

    //Affiche le temps coul en haut a droite du document pdf
  function horloge(){
        //La premire fois on met le champ en lecture seule
        //Attention a bien mettre h1=1 et h2=0 avant d'appeler la fonction
        if((h1==1)&&(h2==0)) getField('horloge').readonly = true;

        if(h1==60){
            h1=0;
            h2++
        }

        if(h2<10) min='0'+h2;
        else min=h2;

        if(h1<10) sec='0'+h1;
        else sec=h1;

        getField('horloge').value = min+':'+sec;
        h1++
		
		if (min==$minutes && min!=0){
		//on arrete l'horloge
		app.clearInterval(s);
		//On met les champs en lecture seule
		$readOnly
		app.alert('Temps coul !');
		}
  }
  function countdown_clock() {
    var timeout_id = null;
    if (quizTimerValue ==$quiztimervalue)
      getField('horloge').readonly = true;
    quizTimerValue = quizTimerValue - 1;
    if(quizTimerValue == 0) {
    	//on arrete l'horloge
		  app.clearInterval(s);
		  //On met les champs en lecture seule
		  $readOnly
		  app.alert('Temps coul !');
    }
    now = quizTimerValue;
    var hours = Math.floor( now / 3600 );
    parseInt(hours);
    now = now - (hours * 3600);
    var minutes = Math.floor(now / 60);
    parseInt(minutes);
    now = now - (minutes * 60);
    var seconds = now;
    parseInt(seconds);
    var t = '' + hours;
    t += ((minutes < 10) ? ':0' : ':') + minutes;
    t += ((seconds < 10) ? ':0' : ':') + seconds;
    getField('horloge').value= t.toString();
    if(hours == 0 && minutes == 0 && seconds <= 15) {
        f=getField('horloge');
        if (!color.equal(color.red, f.fillColor)) {  
          f.fillColor=color.red;
          f.textColor=color.black;
        }        
    }
  }

   // beep et reinitialisation des champs en boucle pour permettre la sauvegarde sous Acrobat pro
   function acropro(){
      app.beep(0);
      this.resetForm();
   }

   //dclaration de la fonction :
   function ajouterNumerotation(doc){
    //cration de lobjet thermometer pour la barre de progression :
     var t = app.thermometer;
     t.begin();
     //valeur maximale de la barre de progression :
     t.duration = this.numPages;
     //on boucle sur toutes les pages du document :
     for (var p = 0; p < doc.numPages; p++) {
       //valeur et texte affich sur la barre de progression
       t.value = p;
       t.text = 'Page ' + (p + 1) + ' en cours de traitement';
       //on cre un champ de formulaire de type texte en bas  droite de la page
       var f = doc.addField('numpage'+p, 'text', p, [448,54,571,17] );
       //on dfinit les proprits du champ quon vient de crer
       f.delay = true;
       f.textSize = 10; //taille du texte
       f.textColor = color.black; //couleur du texte
       f.textFont = font.Times; //police de caractre
       f.value = 'page '+ (p+1) +' sur '+ doc.numPages; //valeur du champ
       f.readonly = true; //on rend le champ non modifiable
       f.delay = false;
     }
     //on est sorti de la boucle, on arrte la barre de progression
     t.end();
   }

    //Cette fonction affiche les corrections du pdf
    function Corrige(){
        //On stoppe le temps
    if($showTime==1){
		  app.clearInterval(s);
    }		
		//Vrouillage des rponses de l'leve
		$readOnly
    //On rend les champs de correction visibles
    $visible
    //Affichage des corrections dans le cadre prvu  cet effet
		$corriger
    $noprint
		var esp='  ';
		getField('nbBR').value = esp + nbQBR[0];
		getField('nbMR').value = esp + nbQMR[0];
		getField('nbNR').value = esp + nbQNR[0];
		getField('ptsBR').value = esp + ptsBR;
		getField('ptsMR').value = esp + ptsMR;
		getField('ptsNR').value = esp + ptsNR;
		var note=(nbQBR[0]*ptsBR+nbQNR[0]*ptsNR+nbQMR[0]*ptsMR);
		if(note<0) note=0;
		  getField('note').value =  esp + note + '/' + (nbQNR[0]+nbQBR[0]+nbQMR[0])*ptsBR;
    var fposC2i=1;
    var sposC2i=0;
    var pposC2i=0;
    for (i=1;i<=nbQ.length-1;i++) {
      if (nbQ[i]>0) {
      var pos=100*(nbQBR[i]*ptsBR+nbQNR[i]*ptsNR+nbQMR[i]*ptsMR)/(nbQ[i]*ptsBR);
      if(pos<0) pos=0;
      getField('p'+i).value = esp + pos;
      } else {
			fposC2i=0;
			}
    }
    if (fposC2i==1){
      var pos=0;
      for (i=1;i<=nbQ.length-1;i++) {
        pos=100*(nbQBR[i]*ptsBR+nbQNR[i]*ptsNR+nbQMR[i]*ptsMR)/(nbQ[i]*ptsBR);
        if(pos<0) pos=0;
        pposC2i=pposC2i+coeff[i]*pos;
        sposC2i=sposC2i+coeff[i];
      }
      getField('pC2I').value = esp + pposC2i/sposC2i;
    }
		//et affichage des liens
		$afficheLien
		 
		//On signale que la correction est termine
        app.alert('Correction termine. Les rsultats sont sur la dernire page');
    }


    //Vrifie le mot de passe pour acceder a la correction
    function verifMdp(){

            //Vrification du mot de passe :
";
  if ($protection==false) {
    $this->pdf->script.="
            if ($needMdp==0 || hex_md5(getField('mdp').value) == '$mdp'){
                  this.Corrige();
            }
  ";} else {$this->pdf->script.="
            if ($needMdp==0 || getField('mdp').value == '$mdp'){
                  this.Corrige();
            }
  ";
  }
  $this->pdf->script.="   else{
                  app.alert('Mot de passe incorrect !');
            }
     }


    //Une fonction (rcupre sur le net) pour chiffrer un mot de passe en MD5(pour plus de securit)
    //Comme le mot de passe est en clair dans la source, il est prfrable qu'il soit en MD5

    var hexcase = 0;  // hex output format. 0 - lowercase; 1 - uppercase
    var b64pad  = '';
    var chrsz   = 8;  // bits per input character. 8 - ASCII; 16 - Unicode

    function hex_md5(s){ return binl2hex(core_md5(str2binl(s), s.length * chrsz));}
    function b64_md5(s){ return binl2b64(core_md5(str2binl(s), s.length * chrsz));}
    function str_md5(s){ return binl2str(core_md5(str2binl(s), s.length * chrsz));}
    function hex_hmac_md5(key, data) { return binl2hex(core_hmac_md5(key, data)); }
    function b64_hmac_md5(key, data) { return binl2b64(core_hmac_md5(key, data)); }
    function str_hmac_md5(key, data) { return binl2str(core_hmac_md5(key, data)); }
    function md5_vm_test()
    {
      return hex_md5('abc') == '900150983cd24fb0d6963f7d28e17f72';
    }
    function core_md5(x, len)
    {
      x[len >> 5] |= 0x80 << ((len) % 32);
      x[(((len + 64) >>> 9) << 4) + 14] = len;

      var a =  1732584193;
      var b = -271733879;
      var c = -1732584194;
      var d =  271733878;

      for(var i = 0; i < x.length; i += 16)
      {
        var olda = a;
        var oldb = b;
        var oldc = c;
        var oldd = d;

        a = md5_ff(a, b, c, d, x[i+ 0], 7 , -680876936);
        d = md5_ff(d, a, b, c, x[i+ 1], 12, -389564586);
        c = md5_ff(c, d, a, b, x[i+ 2], 17,  606105819);
        b = md5_ff(b, c, d, a, x[i+ 3], 22, -1044525330);
        a = md5_ff(a, b, c, d, x[i+ 4], 7 , -176418897);
        d = md5_ff(d, a, b, c, x[i+ 5], 12,  1200080426);
        c = md5_ff(c, d, a, b, x[i+ 6], 17, -1473231341);
        b = md5_ff(b, c, d, a, x[i+ 7], 22, -45705983);
        a = md5_ff(a, b, c, d, x[i+ 8], 7 ,  1770035416);
        d = md5_ff(d, a, b, c, x[i+ 9], 12, -1958414417);
        c = md5_ff(c, d, a, b, x[i+10], 17, -42063);
        b = md5_ff(b, c, d, a, x[i+11], 22, -1990404162);
        a = md5_ff(a, b, c, d, x[i+12], 7 ,  1804603682);
        d = md5_ff(d, a, b, c, x[i+13], 12, -40341101);
        c = md5_ff(c, d, a, b, x[i+14], 17, -1502002290);
        b = md5_ff(b, c, d, a, x[i+15], 22,  1236535329);

        a = md5_gg(a, b, c, d, x[i+ 1], 5 , -165796510);
        d = md5_gg(d, a, b, c, x[i+ 6], 9 , -1069501632);
        c = md5_gg(c, d, a, b, x[i+11], 14,  643717713);
        b = md5_gg(b, c, d, a, x[i+ 0], 20, -373897302);
        a = md5_gg(a, b, c, d, x[i+ 5], 5 , -701558691);
        d = md5_gg(d, a, b, c, x[i+10], 9 ,  38016083);
        c = md5_gg(c, d, a, b, x[i+15], 14, -660478335);
        b = md5_gg(b, c, d, a, x[i+ 4], 20, -405537848);
        a = md5_gg(a, b, c, d, x[i+ 9], 5 ,  568446438);
        d = md5_gg(d, a, b, c, x[i+14], 9 , -1019803690);
        c = md5_gg(c, d, a, b, x[i+ 3], 14, -187363961);
        b = md5_gg(b, c, d, a, x[i+ 8], 20,  1163531501);
        a = md5_gg(a, b, c, d, x[i+13], 5 , -1444681467);
        d = md5_gg(d, a, b, c, x[i+ 2], 9 , -51403784);
        c = md5_gg(c, d, a, b, x[i+ 7], 14,  1735328473);
        b = md5_gg(b, c, d, a, x[i+12], 20, -1926607734);

        a = md5_hh(a, b, c, d, x[i+ 5], 4 , -378558);
        d = md5_hh(d, a, b, c, x[i+ 8], 11, -2022574463);
        c = md5_hh(c, d, a, b, x[i+11], 16,  1839030562);
        b = md5_hh(b, c, d, a, x[i+14], 23, -35309556);
        a = md5_hh(a, b, c, d, x[i+ 1], 4 , -1530992060);
        d = md5_hh(d, a, b, c, x[i+ 4], 11,  1272893353);
        c = md5_hh(c, d, a, b, x[i+ 7], 16, -155497632);
        b = md5_hh(b, c, d, a, x[i+10], 23, -1094730640);
        a = md5_hh(a, b, c, d, x[i+13], 4 ,  681279174);
        d = md5_hh(d, a, b, c, x[i+ 0], 11, -358537222);
        c = md5_hh(c, d, a, b, x[i+ 3], 16, -722521979);
        b = md5_hh(b, c, d, a, x[i+ 6], 23,  76029189);
        a = md5_hh(a, b, c, d, x[i+ 9], 4 , -640364487);
        d = md5_hh(d, a, b, c, x[i+12], 11, -421815835);
        c = md5_hh(c, d, a, b, x[i+15], 16,  530742520);
        b = md5_hh(b, c, d, a, x[i+ 2], 23, -995338651);

        a = md5_ii(a, b, c, d, x[i+ 0], 6 , -198630844);
        d = md5_ii(d, a, b, c, x[i+ 7], 10,  1126891415);
        c = md5_ii(c, d, a, b, x[i+14], 15, -1416354905);
        b = md5_ii(b, c, d, a, x[i+ 5], 21, -57434055);
        a = md5_ii(a, b, c, d, x[i+12], 6 ,  1700485571);
        d = md5_ii(d, a, b, c, x[i+ 3], 10, -1894986606);
        c = md5_ii(c, d, a, b, x[i+10], 15, -1051523);
        b = md5_ii(b, c, d, a, x[i+ 1], 21, -2054922799);
        a = md5_ii(a, b, c, d, x[i+ 8], 6 ,  1873313359);
        d = md5_ii(d, a, b, c, x[i+15], 10, -30611744);
        c = md5_ii(c, d, a, b, x[i+ 6], 15, -1560198380);
        b = md5_ii(b, c, d, a, x[i+13], 21,  1309151649);
        a = md5_ii(a, b, c, d, x[i+ 4], 6 , -145523070);
        d = md5_ii(d, a, b, c, x[i+11], 10, -1120210379);
        c = md5_ii(c, d, a, b, x[i+ 2], 15,  718787259);
        b = md5_ii(b, c, d, a, x[i+ 9], 21, -343485551);

        a = safe_add(a, olda);
        b = safe_add(b, oldb);
        c = safe_add(c, oldc);
        d = safe_add(d, oldd);
      }
      return Array(a, b, c, d);

    }

    function md5_cmn(q, a, b, x, s, t)
    {
      return safe_add(bit_rol(safe_add(safe_add(a, q), safe_add(x, t)), s),b);
    }
    function md5_ff(a, b, c, d, x, s, t)
    {
      return md5_cmn((b & c) | ((~b) & d), a, b, x, s, t);
    }
    function md5_gg(a, b, c, d, x, s, t)
    {
      return md5_cmn((b & d) | (c & (~d)), a, b, x, s, t);
    }
    function md5_hh(a, b, c, d, x, s, t)
    {
      return md5_cmn(b ^ c ^ d, a, b, x, s, t);
    }
    function md5_ii(a, b, c, d, x, s, t)
    {
      return md5_cmn(c ^ (b | (~d)), a, b, x, s, t);
    }

    function core_hmac_md5(key, data)
    {
      var bkey = str2binl(key);
      if(bkey.length > 16) bkey = core_md5(bkey, key.length * chrsz);

      var ipad = Array(16), opad = Array(16);
      for(var i = 0; i < 16; i++)
      {
        ipad[i] = bkey[i] ^ 0x36363636;
        opad[i] = bkey[i] ^ 0x5C5C5C5C;
      }

      var hash = core_md5(ipad.concat(str2binl(data)), 512 + data.length * chrsz);
      return core_md5(opad.concat(hash), 512 + 128);
    }

    function safe_add(x, y)
    {
      var lsw = (x & 0xFFFF) + (y & 0xFFFF);
      var msw = (x >> 16) + (y >> 16) + (lsw >> 16);
      return (msw << 16) | (lsw & 0xFFFF);
    }

    function bit_rol(num, cnt)
    {
      return (num << cnt) | (num >>> (32 - cnt));
    }

    function str2binl(str)
    {
      var bin = Array();
      var mask = (1 << chrsz) - 1;
      for(var i = 0; i < str.length * chrsz; i += chrsz)
        bin[i>>5] |= (str.charCodeAt(i / chrsz) & mask) << (i%32);
      return bin;
    }

    function binl2str(bin)
    {
      var str = '';
      var mask = (1 << chrsz) - 1;
      for(var i = 0; i < bin.length * 32; i += chrsz)
        str += String.fromCharCode((bin[i>>5] >>> (i % 32)) & mask);
      return str;
    }

    function binl2hex(binarray)
    {
      var hex_tab = hexcase ? '0123456789ABCDEF' : '0123456789abcdef';
      var str = '';
      for(var i = 0; i < binarray.length * 4; i++)
      {
        str += hex_tab.charAt((binarray[i>>2] >> ((i%4)*8+4)) & 0xF) +
               hex_tab.charAt((binarray[i>>2] >> ((i%4)*8  )) & 0xF);
      }
      return str;
    }

    function binl2b64(binarray)
    {
      var tab = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/';
      var str = '';
      for(var i = 0; i < binarray.length * 4; i += 3)
      {
        var triplet = (((binarray[i   >> 2] >> 8 * ( i   %4)) & 0xFF) << 16)
                    | (((binarray[i+1 >> 2] >> 8 * ((i+1)%4)) & 0xFF) << 8 )
                    |  ((binarray[i+2 >> 2] >> 8 * ((i+2)%4)) & 0xFF);
        for(var j = 0; j < 4; j++)
        {
          if(i * 8 + j * 6 > binarray.length * 32) str += b64pad;
          else str += tab.charAt((triplet >> 6*(3-j)) & 0x3F);
        }
      }
      return str;
    }
    ";
    //------------------------------------------------------------------------------------------------------------------



    //On inclut tout le JavaScript gnr dans le PDF
    $this->pdf->IncludeJS($this->pdf->script);
    //$this->pdf->IncludeJScript("Corriger","function Corriger() {".$corriger."}");
	//Propose l'affichage ou le tlchargement
	  if ($download==0){
        //affichage du pdf
        $this->pdf->Output();
    }
    else{
        //proposer en tlchargement au lieu d'afficher
        $this->pdf->Output($nomfichier,'D');   //D pour Download
    }
}

/**************************************************************************
 *    Ces fonctions sont utilises par la fonction createQcm
 **************************************************************************/
 
//affiche une question dont l'id est $i
//affiche galement les rponses possibles
function afficheQuestion($i, $dynamique,$num,$corrigeDisp=false){
    require_once('config.php');
 	global $CFG;	

    //requete pour obtenir la question
    $query = "select * from question where idQuestion=$i;";
    $question = mysql_query ($query);
    $quest = mysql_fetch_array ($question);
    if ($num==0){
	$numero="";
    }
    else{
	$numero=$num.". ";
    }
    //Affichage de la question (MultiCell permet le retour a la ligne)
    $this->pdf->MultiCell(190,7,stripCSlashes($numero.$quest[1]),0,"L",1);
    $this->pdf->Ln(5);

	//Affichage d'un image si il y en a une
	$query = "select image from question where idQuestion=$i;";
	$data = mysql_query ($query);
    $image = mysql_fetch_array ($data);
	if($image[0]!=null){
		$image[0]=$CFG->dirroot."/images/".$image[0];
		if (file_exists($image[0])){
		//echo $image[0]."</br>";  
		////rcupration de l'echelle
		//$imagep=explode(",",$image[0]);	
		$imageInfo=getImageSize($image[0]);
		$largeur=$imageInfo[0];
		$hauteur=$imageInfo[1];
		//echo $i, " largeur :".$largeur." hauteur: ".$hauteur." echelle:".$imagep[1]."\n<br/>";
		$nlargeur=$largeur*190/900;
		$nhauteur=$hauteur*($nlargeur/$largeur);
		//$imagel=0;
		//if ($largeur>190) {
		//	$imagel=190;
		//	$hauteur=$hauteur*(190/$largeur);
		//}	
		
		//Si la photo est trop basse on va sur la page d'apres
//		if($this->pdf->GetY()+$hauteur*(2/5)>280){
		if($this->pdf->GetY()+$nhauteur*(5/5)+10>280){

			 $this->pdf->AddPage();
		}
		//if ($largeur>190)
			$this->pdf->Image("$image[0]",$this->pdf->GetX(),$this->pdf->GetY(),$nlargeur,$nhauteur);
			//echo $image[0]."</br>";
		//else	
			//$this->pdf->Image("$image[0]",$this->pdf->GetX(),$this->pdf->GetY());

		//$this->pdf->SetY($this->pdf->GetY()+$hauteur*(2/5));
		$this->pdf->SetY($this->pdf->GetY()+$nhauteur*(5/5))+10;
		}
	}
    $retnb = mysql_query("SELECT reponse, modalite.idModalite FROM question, modalite WHERE question.idQuestion = modalite.idQuestion AND question.idQuestion = ".$i." AND correct = '1' ;");
    $nb = mysql_numrows($retnb);
	
    //Affichage des rponses
    //requete
    $query = "select * from modalite where idQuestion=$i order by idModalite;";
    $modalite = mysql_query ($query);

    $j=0;
    $this->index++;
	  $ev=Array();
    while($mod = mysql_fetch_array ($modalite)){
        //j contient le numro de la rponse

        $j++;
        //dfinit l'espace entre les 2 checkBox
        $decalage=1;
        //On regarde si la rponse est correcte
        $correcte=$mod[2];
        //Astuce pour retourner a la ligne en fin de page
        //Sinon les rponses sont spares de leur case !!
        if ($this->pdf->GetY()>273){
             $this->pdf->AddPage();
        }
        //On affiche la checkBox qui sert de correction
        $this->pdf->CheckBox('c'.$this->index.'-'.$j,4,$correcte,array('TextColor'=>'red','FillColor'=>'blue'));
        $this->pdf->SetX($this->pdf->GetX()+ $decalage);
        //et on affiche la rponse
        if ($nb!=1)
          $this->pdf->CheckBox('r'.$this->index.'-'.$j,4,false);
        else {
          $this->pdf->RadioButton('r'.$this->index,4,$j-1);
          array_push( $ev , ($correcte ? 'Oui' : 'Non'));
          }
			//On affiche une case a cocher si le qcm est statique
		$decalage="";
		if($dynamique==0){
			$ancY=$this->pdf->GetY();				
			if ($corrigeDisp==false) {
			  if ($nb!=1) {
			   $this->pdf->SetFont('ZapfDingbats','',18);
			   $this->pdf->Cell(40,4,'r',0,1);
			  } else {
			   $this->pdf->SetFont('ZapfDingbats','',15);
			   $this->pdf->Cell(40,4,chr(109),0,1);
        }			  
      } else {
      	$this->pdf->SetFont('ZapfDingbats','',18);
        if ($correcte)
          $this->pdf->Cell(40,4,chr(51),0,1);
        else
          $this->pdf->Cell(40,4,chr(55),0,1);        
      }			
			$this->pdf->SetFont('Arial','',11);
			$this->pdf->SetY($ancY);
			$decalage="              ";
		}
		//$this->pdf->MultiCell(190,7,stripCSlashes($numero.$quest[1]),0,"L",1);
		$this->pdf->MultiCell(180,4,stripCSlashes($decalage.$mod[1]),0,1);
    //$this->pdf->Cell(40,4,stripCSlashes($decalage.$mod[1]),0,1);
    
        $this->pdf->Ln(4);
    }
    if ($nb==1)
    $this->pdf->SetExportValues('r'.$this->index,$ev);
	//Affichage d'un champ de texte. Celui-ci contiendra le lien vers des informations sur la question
	$this->pdf->TextField('lien'.$this->index,190,5,array('TextColor'=>'blue'));
	$this->pdf->Ln(8);
		
    //On cr un tableau contenant le nombre de rponses  chaque question
    $this->liste[$this->index]=$j;
    $this->bonne[$this->index]=$nb;
    return $this->pdf;
}

//cr un tableau contenant les id des questions appartenant  la rfrence $ref pour une difficult $diff
function chargeIdQuestion($ref,$niveaumin,$niveaumax){
    $bx=array();
    $query = "select idQuestion from question where idReferentiel='$ref' and niveau>=$niveaumin and niveau<=$niveaumax order by idQuestion;";
    $question = mysql_query ($query);
    $i=0;
    while($quest = mysql_fetch_array ($question)){
        $bx[$i]=$quest[0];
		$i++;
    }
	return $bx;
}

//cette fonction vrifie si une valeur est dans un tableau
//utile pour eviter de choisir deux fois la mme question
function estDans($id, $tab){
	$dedans=0;
	for($i=0; $i<=count($tab)-1; $i++){
		if($tab[$i]==$id){
			$dedans=1;
			break;
		}
	}
return $dedans;
}

}

?>
